code2shelf <- function(package, lib.loc = NULL,
                       keep.source = getOption("keep.source.pkgs")) {
    sQuote <- function(s) paste("'", s, "'", sep = "")
    pkgpath <- .find.package(package, lib.loc, quiet = TRUE)
    if(length(pkgpath) == 0)
        stop(paste("There is no package called", sQuote(package)))
    loadenv <-new.env(hash=TRUE)
    codeFile <- file.path(pkgpath, "R", package)
    saveFile <- file.path(pkgpath, "R", "all.rda")
    loadenv <- new.env(hash = TRUE, parent = .GlobalEnv)
    if(file.exists(codeFile))
        sys.source(codeFile, loadenv, keep.source = keep.source)
    ## now transfer contents of loadenv to a new env to mimic library
    ## the actual copy has to be done by C code to avoid forcing
    ## promises that might have been created using delay().
    env <- new.env(hash=TRUE)
    .Internal(lib.fixup(loadenv, env))
    ## save the package name in the environment
    assign(".packageName", package, envir = env)
    ## save the environment
    shelf <- file.path(pkgpath, "R", "all.shelf")
    s<-makeShelfWriter(shelf, ascii=FALSE)
    for (i in ls(env, all=TRUE))
        s$putvar(i, get(i, env=env))
}
