rda2shelf <- function(package, lib.loc = NULL) {
    sQuote <- function(s) paste("'", s, "'", sep = "")
    pkgpath <- .find.package(package, lib.loc, quiet = TRUE)
    if(length(pkgpath) == 0)
        stop(paste("There is no package called", sQuote(package)))
    rdafile <- file.path(pkgpath, "R", "all.rda")
    if (! file.exists(rdafile))
        stop(paste("Package", sQuote(package), "has no .rda file"))
    shelf <- file.path(pkgpath, "R", "all.shelf")
    s<-makeShelfWriter(shelf, ascii=FALSE)
    e <-new.env(hash=TRUE)
    load(rdafile, e)
    for (i in ls(e, all=TRUE))
        s$putvar(i, get(i, env=e))
}
