local({
    dl <- function(pack) {
        lib <- paste(pack,.Platform$dynlib.ext,sep="")
        dyn.load(system.file(file.path("libs",lib),package=pack))
    }
    dl("serialize")
    dl("gdbm")
    gdbmNew <- function (name) .Call("dbnew", name, PACKAGE = "gdbm")
    gdbmInsert <- function (name, key, value) 
        .Call("dbinsert", name, key, value, PACKAGE = "gdbm")
    serialize <- function (object, conn) 
        .Call("serialize", object, conn, FALSE, NULL, PACKAGE = "serialize")
  
    nsenv <- NULL
    for (name in ls(NULL, all=TRUE)) {
        val <- get(name, env=NULL)
        if (typeof(val) == "closure" &&
            ! identical(environment(val), .BaseNamespaceEnv))
            nsenv <- c(name, nsenv)
    }
    if (! is.null(nsenv))
        for (i in 1:(length(nsenv)-1))
            for (j in (i+1):length(nsenv))
                if (identical(environment(get(nsenv[i], env=NULL)),
                              environment(get(nsenv[j], env=NULL))))
                    stop("cannot handle shared environments in base")
    if (length(search()[search()!="Autoloads"]) != 2)
        stop("start R with NO packages loaded to create the data base")
                
    basedb <- file.path(.Library,"base","R","base.gdbm")
    gdbmNew(basedb)

    for (name in ls(NULL, all=TRUE)) {
        val <- get(name, env=NULL)
        gdbmInsert(basedb, name, serialize(val, NULL))
    }
})
