require("serialize", quiet=TRUE)
require("gdbm", quiet=TRUE)
require("shelf", quiet=TRUE)  # needs to be here for methods
.First.lib <- function(libname, pkgname)
{
    fullName <- paste("package", pkgname, sep=":")
    myEnv <- as.environment(match(fullName, search()))
    shelfFile <- file.path(libname, pkgname, "R", "all.shelf")
    rm(.First.lib, envir = myEnv)
    loadShelf(shelfFile, myEnv)
    if(exists(".First.lib", envir = myEnv, inherits = FALSE)) {
        f <- get(".First.lib", envir = myEnv, inherits = FALSE)
        if(is.function(f))
            f(libname, pkgname)
        else
            stop(paste("package \"", pkgname,
                       "\"has a non-function .First.lib", sep=""))
    }
}
